using System;
class Program
{
    static ulong Deli(ulong n)
    {
        if (n == 1)
            return 1;
        else
        {
            ulong rez = n ^ 1;
            for (ulong i = 2; i <= n / 2; i++)
                if (n % i == 0)
                    rez = rez ^ i;
            return rez;
        }
    }
    static void Main()
    {
        string[] s = Console.ReadLine().Split();
        ulong n = ulong.Parse(s[0]);
        ulong k = ulong.Parse(s[1]);
        ulong[] d = new ulong[k];
        s = Console.ReadLine().Split();
        for (ulong i = 0; i < k; i++)
        {
            d[i] = ulong.Parse(s[i]);
            Console.Write(Deli(d[i]) + " ");
        }
    }
}